--
-- fieldSell
-- 
-- 
--
-- upsideDown 28.05.2014
-- converted to LS15, added chainSaw 'support': 15.11.2014

fieldSell = {};
addModEventListener(fieldSell);
function fieldSell.prerequisitesPresent(specializations)
    return true;
end;

function fieldSell:loadMap(name)
	fieldSell.activeFieldNumber = 1;
	fieldSell.buttonCnt = 0;

	fieldSell.buttonCntMax = 150; --ms, change here to increase/decrease field number scrolling
	print("--- loading fieldSell mod V1.0 (by upsidedown) ---")
end;

function fieldSell:deleteMap()
end


function fieldSell:mouseEvent(posX, posY, isDown, isUp, button)
end;

function fieldSell:keyEvent(unicode, sym, modifier, isDown)
end;


function fieldSell:update(dt)
	if g_currentMission:getIsClient() then
		if g_gui.currentGui == nil then
			if g_currentMission:getIsServer() or g_currentMission.isMasterUser then
				if g_currentMission.controlledVehicle == nil then
			
					if InputBinding.isPressed(InputBinding.fieldSell_mod) then
						
						if g_currentMission.player ~= nil then
							if g_currentMission.player.currentToolId ~= 0 then
								g_currentMission.player:setTool() --remove chainsaws etc
							end;
						end;
						
						if InputBinding.isPressed(InputBinding.fieldSell_up) and fieldSell.buttonCnt <= 0 then
							local maxFieldNumber = table.getn(g_currentMission.fieldDefinitionBase.fieldDefsByFieldNumber);
							fieldSell.activeFieldNumber = fieldSell.activeFieldNumber+1;
							fieldSell.activeFieldNumber = math.min(fieldSell.activeFieldNumber,maxFieldNumber);
							fieldSell.buttonCnt = fieldSell.buttonCntMax;
						end;
						
						if InputBinding.isPressed(InputBinding.fieldSell_down) and fieldSell.buttonCnt <= 0 then							
							fieldSell.activeFieldNumber = fieldSell.activeFieldNumber-1;
							fieldSell.activeFieldNumber = math.max(fieldSell.activeFieldNumber,1);
							fieldSell.buttonCnt = fieldSell.buttonCntMax;
						end;
						
						fieldSell.buttonCnt = math.max(fieldSell.buttonCnt-dt,0);
						
						local field = g_currentMission.fieldDefinitionBase.fieldDefsByFieldNumber[fieldSell.activeFieldNumber];
												
						if InputBinding.hasEvent(InputBinding.fieldSell_sell) then	
							if field.ownedByPlayer then
								g_client:getServerConnection():sendEvent(FieldSoldByPlayerEvent:new(fieldSell.activeFieldNumber));
							else
								g_client:getServerConnection():sendEvent(FieldOwnedByPlayerEvent:new(fieldSell.activeFieldNumber, true));
							end;						
						end;
						
						if fieldSell.activeFieldNumber > 1 then
							g_currentMission:addHelpButtonText(g_i18n:getText("FieldSellDown"), InputBinding.fieldSell_down);
						end;
						if fieldSell.activeFieldNumber < table.getn(g_currentMission.fieldDefinitionBase.fieldDefsByFieldNumber) then
							g_currentMission:addHelpButtonText(g_i18n:getText("FieldSellUp"), InputBinding.fieldSell_up);
						end;
						
						if field.ownedByPlayer then
							local str = string.format(g_i18n:getText("FieldSell_sell"),fieldSell.activeFieldNumber).." "..g_i18n:formatMoney(0.5*field.fieldPrice);
							g_currentMission:addHelpButtonText(str, InputBinding.fieldSell_sell);							
						else
							if g_currentMission.missionStats.money >= field.fieldPrice then
								local str = string.format(g_i18n:getText("FieldSell_buy"),fieldSell.activeFieldNumber).." "..g_i18n:formatMoney(field.fieldPrice);
								g_currentMission:addHelpButtonText(str, InputBinding.fieldSell_sell);
							else
								local str = string.format(g_i18n:getText("FieldSell_tooExpensive"),fieldSell.activeFieldNumber).." ("..g_i18n:formatMoney(field.fieldPrice)..")";
								g_currentMission:addHelpButtonText(str, InputBinding.fieldSell_sell);
							end;
						end;						
						
					else
						g_currentMission:addHelpButtonText(g_i18n:getText("openFieldSell"), InputBinding.fieldSell_mod);
					end;					
				end;
			end;
		end;
	end
end


function fieldSell:draw()   
end;

FieldSoldByPlayerEvent = {}
FieldSoldByPlayerEvent_mt = Class(FieldSoldByPlayerEvent, Event)
InitEventClass(FieldSoldByPlayerEvent, "FieldSoldByPlayerEvent")
function FieldSoldByPlayerEvent:emptyNew()
  local self = Event:new(FieldSoldByPlayerEvent_mt)
  return self
end
function FieldSoldByPlayerEvent:new(fieldNumber)
  local self = FieldSoldByPlayerEvent:emptyNew()
  self.fieldNumber = fieldNumber  
  return self
end
function FieldSoldByPlayerEvent:readStream(streamId, connection)
  self.fieldNumber = streamReadUIntN(streamId, 14)  
  self:run(connection)
end
function FieldSoldByPlayerEvent:writeStream(streamId, connection)
  streamWriteUIntN(streamId, self.fieldNumber, 14)  
end
function FieldSoldByPlayerEvent:run(connection)
  local fieldDef = g_currentMission.fieldDefinitionBase.fieldDefsByFieldNumber[self.fieldNumber]
  if not connection:getIsServer() then
    if fieldDef.ownedByPlayer then
      local user = g_currentMission:findUserByConnection(connection)
      if user ~= nil and user.userId >= 0 then
        local userId = user.userId
        local money = g_currentMission:getMoney(userId)
        if user.isMasterUser then
          userId = g_currentMission:getServerUserId()
          money = g_currentMission:getMoney(userId)
        end		
          g_currentMission:addMoney(0.5*fieldDef.fieldPrice, userId, "other")
          g_server:broadcastEvent(self,true)
      end
    end
  else
    g_currentMission.fieldDefinitionBase:setFieldOwnedByPlayer(fieldDef, false)
  end
end